:start
cls

@echo off
setlocal enabledelayedexpansion


:: ========================================================================
::                                 ६
:: ========================================================================
set tmpHexFileMask="5093v18.hex.tmp"
set hexFileMask="5093v18.hex"
set eepFileMask="5093v18.eep"
set macAddressFile="_mac.txt"
set injectedMacFile="_mac.injected.txt"
set macAddressBase=0x7ffc
set failMessage=0
set successMessage=0


:: ========================================================================
::            ⥫   hex-䠩 訢
:: ========================================================================
:__step_1
echo.======
echo. 1.  ⥫   hex-䠩 訢
echo.======

:searchOld
set isOldFound=0
for %%A IN (%tmpHexFileMask%) DO (set isOldFound=1 && set oldHexOutFile=%%A)
if not %isOldFound%==0 (
	del /f /q %oldHexOutFile%
)

:searchHex
set isHexFound=0
for %%A IN (%hexFileMask%) DO (set isHexFound=1 && set hexFile=%%A)
if not %isHexFound%==1 (
	set failMessage=  hex-䠩 訢 
	goto fail
)

:searchEep
set isEepFound=0
for %%A IN (%eepFileMask%) DO (set isEepFound=1 && set eepFile=%%A)
if not %isEepFound%==1 (
	set failMessage=  eep-䠩 訢 
	goto fail
)

:patch
_hexInjector --macAddressFile=%macAddressFile% --macAddressBase=%macAddressBase% --macAddressInjectedFile=%injectedMacFile% --hexFile=%hexFile% --tmpHexFile=%hexFile%.tmp
if errorlevel 1 (
	set failMessage= 㤠 ࠡ 䠩 %macAddressFile%
	goto fail
)


:: ========================================================================
::                                 訢
:: ========================================================================
:__step_2
echo.
echo.======
echo. 2. 訢 ப஫
echo.======

:flash_fuses
_avreal32-1.28r1.exe -aft2232:reset=adbus3:enable=adbus4 -pd="Pritok Programmer PPKOP-02 A" -e -w -v +mega32 -f_low=3F,_high=CF,_lock=FC -%%
if errorlevel 1 (
	set failMessage= 㤠  fuse-bits ப஫ 
	goto fail
)

:flash_hex
_avreal32-1.28r1.exe -aft2232:reset=adbus3:enable=adbus4 -pd="Pritok Programmer PPKOP-02 A" -o10MHz -w -v -c %hexFile%.tmp -d %eepFile% +mega32 -l2 -%%
if errorlevel 1 (
	set failMessage= 㤠  ப஫ 
	goto fail
)

:macAddressIncrement
_hexInjector --macAddressFile=%macAddressFile% --macAddressIncrement
if errorlevel 1 (
	set failMessage= 㤠 ६஢ 祭 mac-  䠩 %macAddressFile%
	goto fail
)

:formSuccessMessage
set /p injectedMac=< %injectedMacFile%
set successMessage= mac-: %injectedMac%
goto success


:: ========================================================================
::                                 
:: ========================================================================
:fail
echo.
echo.=======
echo.訡: %failMessage%
echo.=======
goto end

:success
echo.
echo.======
echo.ᯥ: %successMessage%
echo.======
goto end


:end
pause
goto start